// ----------------------------------------------------------------------------
//
//  Project:
//  Example of using Delphi with Backup-Burner.dll ver. 6
//  February, 2002
//  2002 FrontBack LLC
//  Produced by: D. Clark
//
//  Compiles in Delphi 5,6 without hints, warnings, or errors.
//
// ----------------------------------------------------------------------------

unit Unit1;

interface
{$WARN UNIT_PLATFORM OFF}//To quiet D6 compiler

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,  FileCtrl,
  Registry, StdCtrls, Menus, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    ButtonStep2: TButton;
    ButtonStep3: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    BackuptoCD1: TMenuItem;
    Panel1: TPanel;
    Label5: TLabel;
    Label4: TLabel;
    ResultsLabel: TLabel;
    procedure ButtonStep2Click(Sender: TObject);
    procedure ButtonStep3Click(Sender: TObject);
    procedure ExitClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ResultCode: Integer;
    BBRegName,
    BBRegCode,
    BBVolume,
    BBTitle,
    BBColorForm,
    BBColorText,
    BBFolderPath,
    BBFutureUse: String;

implementation

{$R *.DFM}


procedure TForm1.ButtonStep2Click(Sender: TObject);
var
    SPath: String;
begin
    SPath:= ExtractFilePath(ParamStr(0));
    if SelectDirectory(SPath, [sdAllowCreate, sdPerformCreate, sdPrompt], 1000) then
    begin
        MessageDlg('The folder that will be backed up to CD: '#13#13+SPath, mtInformation, [mbOK], 0);
        BBFolderPath := SPath;
    end;

end;

procedure TForm1.ButtonStep3Click(Sender: TObject);
// Temporarily Disable your Burn CD button or menu option to avoid double clicks
// Fill in registration numbers, and
// OPTIONAL- Fill in desired Volume name (to be burned as CD title) or use null '';
// Hide or minimize your program
// Launch MakeBackupCD function in BackupBurner.dll
// When function returns, the CD process is complete.
// Unhide or restore your program
// OPTIONAL- Inspect the result code
// You are done.
var
  H: THandle;
  MakeBackupCD: function(BBRegName, BBRegCode, BBVolume, BBTitle, BBColorForm, BBColorText, BBFolderPath, BBFutureUse: PChar): integer; stdcall;
begin
// Fill in registration numbers, and
// OPTIONAL- Fill in desired Volume name (to be burned as CD title) or use null '';

    BBRegName   :=  'DEMOUSER';
    BBRegCode   :=  'ABCD1234';
    BBVolume    :=  'MyBackupCD'; //' What ever you want here up to 16 chars
    BBTitle     :=  Memo1.Lines[0] + Memo1.Lines[1] ;//This is your program title to display on the recording form.
    BBColorForm :=  'clWhite';//default is clWhite, don't use hex color
    BBColorText :=  'clBlack';//default is clBlack, don't use hex color
    BBFutureUse :=  '';
    if BBFolderPath='' then   // Make BBFolderPath any folder containing your desired files.
        begin
        MessageDlg('Please select a folder with button #2', mtInformation, [mbOK], 0); 
        exit;
        end;

// Temporarily Disable Burn CD button to avoid double clicks
    ButtonStep3.Enabled := False;

// Hide or minimize your program
   Application.Minimize;

// Launch MakeBackupCD function in BackupBurner.dll
// When function returns, the CD process is complete...
  If FileExists(ExtractFilePath(ParamStr(0))  + 'Bin\'+ 'BackupBurner.dll') then
   begin
    ResultCode := 100;
    H := LoadLibrary( Pchar(ExtractFilePath(ParamStr(0))  + 'Bin\'+ 'BackupBurner.dll') );
    if  H <> 0 then
      begin
        try
            @MakeBackupCD := GetProcAddress(H, 'MakeBackupCD');
            if  Assigned(MakeBackupCD)   then
            ResultCode := MakeBackupCD(PChar(BBRegName), PChar(BBRegCode), PChar(BBVolume), PChar(BBTitle), PChar(BBColorForm), PChar(BBColorText), PChar(BBFolderPath), PChar(BBFutureUse) );
        finally
            FreeLibrary(H);
        end;
      end;
   end
   else
   begin
    ResultsLabel.Caption := 'Result: BackupBurner.dll file not found in the path ';
    Application.Restore;
    Application.ProcessMessages;
    Sleep(5000); //show the demo for 5 seconds then close form.
    close;
   end;

// Now the CD process is complete.
// Unhide or restore your program
    Application.Restore;
    ButtonStep3.Enabled := True;

// OPTIONAL- Inspect the result code
    Case ResultCode of
   -2: ResultsLabel.Caption := 'Result: ResultCode = -2 Installation Error- version mismatch';
   -1: ResultsLabel.Caption := 'Result: ResultCode = -1 User canceled' ;
    0: ResultsLabel.Caption := 'Result: ResultCode = 0  it was a successful burn!';
    1: ResultsLabel.Caption := 'Result: ResultCode = 1  User canceled';
    2: ResultsLabel.Caption := 'Result: ResultCode = 2  Installation Error- files missing';
    3: ResultsLabel.Caption := 'Result: ResultCode = 3  Insufficent disk space';
    5: ResultsLabel.Caption := 'Result: ResultCode = 5  there was not a blank CD';
    7: ResultsLabel.Caption := 'Result: ResultCode = 7  bad burn during writing ';
    8: ResultsLabel.Caption := 'Result: ResultCode = 8  no CD recorder detected. ';
    9: ResultsLabel.Caption := 'Result: ResultCode = 9  Demo expired. ';
   11: ResultsLabel.Caption := 'Result: ResultCode = 11 User does not have admin rights to access the ASPI manager. ';
    else
     ResultsLabel.Caption := 'Result: There was an unknown result.';
    end;

// You are done.
end;


procedure TForm1.ExitClick(Sender: TObject);
begin
     Close;
end;

end.
